//-----------------------------------------------------------------------
// class IGhost
//
//
// Author:  Sylvain Lefebvre
// History: Created 04/04/2002
//-----------------------------------------------------------------------
#ifndef __IGHOST__
#define __IGHOST__
//-----------------------------------------------------------------------
#include "INetworkObject.h"
#include "INetworkGame.h"
//-----------------------------------------------------------------------
class IGhost : public virtual INetworkObject
{
private:

  INetworkGame *m_Ng;

protected:
  
  int              m_iGhostId;
  int              m_iGhostType;
  unsigned char   *m_InitData;
  int              m_iLenInitData;
  int              m_iMasterClientId;

public:

  IGhost();
  IGhost(int t,int id,const unsigned char *d,int l);
  virtual ~IGhost();
  
  void         sendMessageToMaster(int,const unsigned char *,int);

  virtual void setGhostData(const unsigned char *d,int l)                  {readNetworkData(d,l);}
  virtual void messageFromMaster(ng_ghost_msg *,const unsigned char *,int) {};

  virtual int                  getGhostInitDataSize();
  virtual const unsigned char *getGhostInitData();

  virtual void                 onGhostReady()         {}
  virtual void                 onGhostMasterDied()    {}

  void setNetworkGame(INetworkGame *ng);

  void setGhostId(int i)   {m_iGhostId=i;}
  int  getGhostId()        {return (m_iGhostId);}
  void setGhostType(int i) {m_iGhostType=i;}
  int  getGhostType()      {return (m_iGhostType);}
  void setMasterClientId(int i) {m_iMasterClientId=i;}
  int  getMasterClientId()      {return (m_iMasterClientId);}

  bool isGhost() {return (m_iGhostId >= 0);}
};
//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------
// ---------------------------------------------------------- 
// Sylvain Lefebvre - (c) 2002 - Sylvain.Lefebvre@laposte.net
// ----------------------------------------------------------
