// -------------------------------------------------------------------------
#include <math.h>
#include "CVertex.h"
#include "messages_CVertex.h"
// -------------------------------------------------------------------------
double CVertex::s_dEpsilon=0.0001;
// -------------------------------------------------------------------------
double	CVertex::dist(const CVertex&	p) const
{
  const double	&tmp1 = m_dX - p.m_dX;
  const double	&tmp2 = m_dY - p.m_dY;
  const double	&tmp3 = m_dZ - p.m_dZ;

  return sqrt(tmp1 * tmp1 + tmp2 * tmp2 + tmp3 * tmp3);
}
// -------------------------------------------------------------------------
double	CVertex::normalize()
{
  double tmp = sqrt(m_dX * m_dX + m_dY * m_dY + m_dZ * m_dZ);

  if (tmp < CVertex::s_dEpsilon)
    throw CException(MSG_vec_null);
  m_dX /= tmp;
  m_dY /= tmp;
  m_dZ /= tmp;
  return (tmp);
}
// -------------------------------------------------------------------------
