/* $ANTLR 2.7.3rc2: "calc.g" -> "CalcLexer.cpp"$ */
#line 11 "calc.g"

#include "CException.h"
#include "MyASTNode.h" // $FAB
#include "CMobile.h"
#include "CWorld.h"
#include "messages_calc.h"

extern int cur_line;
extern int cur_mob;
#define getCurLine() (cur_line+1) 
#define warning(msg) display_warning(msg,m_Mobile_id+1,getCurLine())
    
#define ME            	        -1
#define MOUSE          		-2
#define COLLIDER       		-3
#define PREV           		-4
#define NEXT       	    	-5
#define NEAREST        		-6
#define NEAREST2       		-7
#define NEAREST3       		-8
#define NEAREST_LEFT   		-9
#define NEAREST_RIGHT 	       -10
#define NEAREST_UP    	       -11
#define NEAREST_DOWN  	       -12
#define EMPTY         	       -13
#define NEAREST_INDIR 	       -14
#define NEAREST_INDIR2 	       -15
#define NEAREST_INDIR3	       -16
#define CAMERA                 -17
#define LIGHT1                 -18
#define LIGHT2                 -19
#define LIGHT3                 -20

// flags pour get*Ptr()
#define MOVEABLE               0x01
#define NOT_PSEUDOMOBILES      0x02
#define NOT_ME                 0x04
#define NOT_ME_IF_START      ( (field==FIELD_START)?NOT_ME:0 )

// flags pour get*Ref()
#define CREATE_ON_FAIL 0x01
#define MUST_EXIST     0x02

// macros utiles
#define is_local(ib) ( ((ib) == -1) || ((ib)-1 == m_Mobile_client_id) )

#define is_me(ia,ib) ( is_local(ib) &&      \
          ( ( (ia) == -1) || ( (ia)-1 == m_Mobile_id ) )    )

#define conv_ref_to_number(mob) (                       \
   ( is_local((mob).client) && ((mob).mobile>-1) )      \
        ? (mob).mobile                                  \
        : WORLD.getMobileLocalId(getMobilePtr(mob))  )


#define RED     "4278190080" // 0xff000000
#define GREEN     "16711680" // 0x00ff0000
#define BLUE         "65280" // 0x0000ff00
#define YELLOW  "4294901760" // 0xffff0000
#define CYAN      "16776960" // 0x00ffff00
#define PURPLE  "4278255360" // 0xff00ff00
#define WHITE   "4294967040" // 0xffffff00
#define BLACK            "0" // 0x00000000
#define GRAY    "2155905024" // 0x80808000
#define ORANGE  "4287102976" // 0xff880000

#line 70 "CalcLexer.cpp"
#include "CalcLexer.hpp"
#include <antlr/CharBuffer.hpp>
#include <antlr/TokenStreamException.hpp>
#include <antlr/TokenStreamIOException.hpp>
#include <antlr/TokenStreamRecognitionException.hpp>
#include <antlr/CharStreamException.hpp>
#include <antlr/CharStreamIOException.hpp>
#include <antlr/NoViableAltForCharException.hpp>

#line 1 "calc.g"
#line 81 "CalcLexer.cpp"
CalcLexer::CalcLexer(ANTLR_USE_NAMESPACE(std)istream& in)
	: ANTLR_USE_NAMESPACE(antlr)CharScanner(new ANTLR_USE_NAMESPACE(antlr)CharBuffer(in),true)
{
	initLiterals();
}

CalcLexer::CalcLexer(ANTLR_USE_NAMESPACE(antlr)InputBuffer& ib)
	: ANTLR_USE_NAMESPACE(antlr)CharScanner(ib,true)
{
	initLiterals();
}

CalcLexer::CalcLexer(const ANTLR_USE_NAMESPACE(antlr)LexerSharedInputState& state)
	: ANTLR_USE_NAMESPACE(antlr)CharScanner(state,true)
{
	initLiterals();
}

void CalcLexer::initLiterals()
{
	literals["contact"] = 32;
	literals["nearest_second"] = 100;
	literals["log"] = 49;
	literals["sqrt"] = 41;
	literals["gray"] = 25;
	literals["unclick"] = 52;
	literals["angle"] = 19;
	literals["norm"] = 67;
	literals["shocky"] = 27;
	literals["dx"] = 17;
	literals["click"] = 51;
	literals["color"] = 21;
	literals["restart"] = 7;
	literals["exp"] = 48;
	literals["y"] = 16;
	literals["min"] = 62;
	literals["key_up"] = 56;
	literals["pi"] = 110;
	literals["Pi"] = 111;
	literals["CYAN"] = 116;
	literals["acs"] = 46;
	literals["nearest_up"] = 104;
	literals["abs"] = 42;
	literals["BLACK"] = 119;
	literals["shockx"] = 26;
	literals["and"] = 78;
	literals["sin"] = 43;
	literals["x"] = 15;
	literals["key_right"] = 55;
	literals["GREEN"] = 113;
	literals["light_one"] = 93;
	literals["sgn"] = 66;
	literals["PI"] = 109;
	literals["RED"] = 112;
	literals["sqr"] = 40;
	literals["nearest_left"] = 102;
	literals["mem"] = 33;
	literals["trace"] = 13;
	literals["light_three"] = 95;
	literals["echo"] = 10;
	literals["GRAY"] = 120;
	literals["blue"] = 24;
	literals["nearest_in_dir_third"] = 108;
	literals["next"] = 90;
	literals["asn"] = 47;
	literals["key_left"] = 54;
	literals["endif"] = 84;
	literals["light_two"] = 94;
	literals["tan"] = 45;
	literals["mod"] = 68;
	literals["nearest_in_dir"] = 106;
	literals["nearest_down"] = 105;
	literals["key_space"] = 58;
	literals["dist"] = 69;
	literals["icon"] = 20;
	literals["nearest_third"] = 101;
	literals["YELLOW"] = 115;
	literals["width"] = 28;
	literals["prev"] = 89;
	literals["rnd"] = 59;
	literals["or"] = 79;
	literals["ORANGE"] = 121;
	literals["max"] = 63;
	literals["dt"] = 71;
	literals["key_down"] = 57;
	literals["height"] = 29;
	literals["collider"] = 98;
	literals["PURPLE"] = 117;
	literals["ang"] = 61;
	literals["srnd"] = 60;
	literals["nearest_right"] = 103;
	literals["like"] = 8;
	literals["frac"] = 65;
	literals["WHITE"] = 118;
	literals["nearest_in_dir_second"] = 107;
	literals["BLUE"] = 114;
	literals["clicked"] = 53;
	literals["cos"] = 44;
	literals["stop"] = 5;
	literals["if"] = 4;
	literals["int"] = 64;
	literals["me"] = 88;
	literals["zoom"] = 30;
	literals["mouse"] = 97;
	literals["t"] = 70;
	literals["dy"] = 18;
	literals["else"] = 83;
	literals["nearest"] = 99;
	literals["green"] = 23;
	literals["clic"] = 50;
	literals["camera"] = 92;
	literals["start"] = 6;
	literals["visible"] = 31;
	literals["EMPTY"] = 91;
	literals["then"] = 82;
	literals["red"] = 22;
	literals["move_to"] = 9;
}

ANTLR_USE_NAMESPACE(antlr)RefToken CalcLexer::nextToken()
{
	ANTLR_USE_NAMESPACE(antlr)RefToken theRetToken;
	for (;;) {
		ANTLR_USE_NAMESPACE(antlr)RefToken theRetToken;
		int _ttype = ANTLR_USE_NAMESPACE(antlr)Token::INVALID_TYPE;
		resetText();
		try {   // for lexical and char stream error handling
			switch ( LA(1)) {
			case static_cast<unsigned char>('.'):
			case static_cast<unsigned char>('0'):
			case static_cast<unsigned char>('1'):
			case static_cast<unsigned char>('2'):
			case static_cast<unsigned char>('3'):
			case static_cast<unsigned char>('4'):
			case static_cast<unsigned char>('5'):
			case static_cast<unsigned char>('6'):
			case static_cast<unsigned char>('7'):
			case static_cast<unsigned char>('8'):
			case static_cast<unsigned char>('9'):
			{
				mINT(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('\n'):
			{
				mNEWLINE(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('('):
			{
				mLPAREN(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>(')'):
			{
				mRPAREN(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('*'):
			{
				mSTAR(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('+'):
			{
				mPLUS(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('-'):
			{
				mMINUS(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>(';'):
			{
				mSEMI(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>(':'):
			{
				mCOLON(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>(','):
			{
				mCOMMA(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('@'):
			{
				mAT(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('='):
			{
				mEQUAL(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('A'):
			case static_cast<unsigned char>('B'):
			case static_cast<unsigned char>('C'):
			case static_cast<unsigned char>('D'):
			case static_cast<unsigned char>('E'):
			case static_cast<unsigned char>('F'):
			case static_cast<unsigned char>('G'):
			case static_cast<unsigned char>('H'):
			case static_cast<unsigned char>('I'):
			case static_cast<unsigned char>('J'):
			case static_cast<unsigned char>('K'):
			case static_cast<unsigned char>('L'):
			case static_cast<unsigned char>('M'):
			case static_cast<unsigned char>('N'):
			case static_cast<unsigned char>('O'):
			case static_cast<unsigned char>('P'):
			case static_cast<unsigned char>('Q'):
			case static_cast<unsigned char>('R'):
			case static_cast<unsigned char>('S'):
			case static_cast<unsigned char>('T'):
			case static_cast<unsigned char>('U'):
			case static_cast<unsigned char>('V'):
			case static_cast<unsigned char>('W'):
			case static_cast<unsigned char>('X'):
			case static_cast<unsigned char>('Y'):
			case static_cast<unsigned char>('Z'):
			case static_cast<unsigned char>('_'):
			case static_cast<unsigned char>('a'):
			case static_cast<unsigned char>('b'):
			case static_cast<unsigned char>('c'):
			case static_cast<unsigned char>('d'):
			case static_cast<unsigned char>('e'):
			case static_cast<unsigned char>('f'):
			case static_cast<unsigned char>('g'):
			case static_cast<unsigned char>('h'):
			case static_cast<unsigned char>('i'):
			case static_cast<unsigned char>('j'):
			case static_cast<unsigned char>('k'):
			case static_cast<unsigned char>('l'):
			case static_cast<unsigned char>('m'):
			case static_cast<unsigned char>('n'):
			case static_cast<unsigned char>('o'):
			case static_cast<unsigned char>('p'):
			case static_cast<unsigned char>('q'):
			case static_cast<unsigned char>('r'):
			case static_cast<unsigned char>('s'):
			case static_cast<unsigned char>('t'):
			case static_cast<unsigned char>('u'):
			case static_cast<unsigned char>('v'):
			case static_cast<unsigned char>('w'):
			case static_cast<unsigned char>('x'):
			case static_cast<unsigned char>('y'):
			case static_cast<unsigned char>('z'):
			{
				mID(true);
				theRetToken=_returnToken;
				break;
			}
			case static_cast<unsigned char>('\t'):
			case static_cast<unsigned char>('\r'):
			case static_cast<unsigned char>(' '):
			{
				mWS_(true);
				theRetToken=_returnToken;
				break;
			}
			default:
				if ((LA(1) == static_cast<unsigned char>('/')) && (LA(2) == static_cast<unsigned char>('/'))) {
					mCOMMENT(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('>')) && (LA(2) == static_cast<unsigned char>('='))) {
					mGEQ(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('<')) && (LA(2) == static_cast<unsigned char>('='))) {
					mLEQ(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('<')) && (LA(2) == static_cast<unsigned char>('>'))) {
					mNEQ(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('/')) && (true)) {
					mDIV(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('>')) && (true)) {
					mGREATER(true);
					theRetToken=_returnToken;
				}
				else if ((LA(1) == static_cast<unsigned char>('<')) && (true)) {
					mLESS(true);
					theRetToken=_returnToken;
				}
			else {
				if (LA(1)==EOF_CHAR)
				{
					uponEOF();
					_returnToken = makeToken(ANTLR_USE_NAMESPACE(antlr)Token::EOF_TYPE);
				}
				else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());}
			}
			}
			if ( !_returnToken )
				goto tryAgain; // found SKIP token

			_ttype = _returnToken->getType();
			_returnToken->setType(_ttype);
			return _returnToken;
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& e) {
				throw ANTLR_USE_NAMESPACE(antlr)TokenStreamRecognitionException(e);
		}
		catch (ANTLR_USE_NAMESPACE(antlr)CharStreamIOException& csie) {
			throw ANTLR_USE_NAMESPACE(antlr)TokenStreamIOException(csie.io);
		}
		catch (ANTLR_USE_NAMESPACE(antlr)CharStreamException& cse) {
			throw ANTLR_USE_NAMESPACE(antlr)TokenStreamException(cse.getMessage());
		}
tryAgain:;
	}
}

void CalcLexer::mCOMMENT(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = COMMENT;
	int _saveIndex;
	
	match("//");
	{ // ( ... )*
	for (;;) {
		if ((_tokenSet_0.member(LA(1)))) {
			{
			match(_tokenSet_0);
			}
		}
		else {
			goto _loop232;
		}
		
	}
	_loop232:;
	} // ( ... )*
	if ( inputState->guessing==0 ) {
#line 1176 "calc.g"
		_ttype = ANTLR_USE_NAMESPACE(antlr)Token::SKIP;
#line 439 "CalcLexer.cpp"
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mDIGITS(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = DIGITS;
	int _saveIndex;
	
	{ // ( ... )+
	int _cnt235=0;
	for (;;) {
		if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
			matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
		}
		else {
			if ( _cnt235>=1 ) { goto _loop235; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());}
		}
		
		_cnt235++;
	}
	_loop235:;
	}  // ( ... )+
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mINT(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = INT;
	int _saveIndex;
	
	bool synPredMatched240 = false;
	if ((((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9'))) && (_tokenSet_1.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true))) {
		int _m240 = mark();
		synPredMatched240 = true;
		inputState->guessing++;
		try {
			{
			mDIGITS(false);
			match(static_cast<unsigned char>('.'));
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched240 = false;
		}
		rewind(_m240);
		inputState->guessing--;
	}
	if ( synPredMatched240 ) {
		mDIGITS(false);
		match(static_cast<unsigned char>('.'));
		{ // ( ... )*
		for (;;) {
			if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9')))) {
				matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
			}
			else {
				goto _loop242;
			}
			
		}
		_loop242:;
		} // ( ... )*
		if ( inputState->guessing==0 ) {
#line 1193 "calc.g"
			_ttype = FLOAT;
#line 516 "CalcLexer.cpp"
		}
	}
	else {
		bool synPredMatched238 = false;
		if (((LA(1) == static_cast<unsigned char>('.')))) {
			int _m238 = mark();
			synPredMatched238 = true;
			inputState->guessing++;
			try {
				{
				match(static_cast<unsigned char>('.'));
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched238 = false;
			}
			rewind(_m238);
			inputState->guessing--;
		}
		if ( synPredMatched238 ) {
			match(static_cast<unsigned char>('.'));
			mDIGITS(false);
			if ( inputState->guessing==0 ) {
#line 1191 "calc.g"
				_ttype = FLOAT;
#line 542 "CalcLexer.cpp"
			}
		}
		else if (((LA(1) >= static_cast<unsigned char>('0') && LA(1) <= static_cast<unsigned char>('9'))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
			mDIGITS(false);
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mNEWLINE(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = NEWLINE;
	int _saveIndex;
	
	match(static_cast<unsigned char>('\n'));
	if ( inputState->guessing==0 ) {
#line 1197 "calc.g"
		newline();
#line 569 "CalcLexer.cpp"
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mLPAREN(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = LPAREN;
	int _saveIndex;
	
	match(static_cast<unsigned char>('('));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mRPAREN(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = RPAREN;
	int _saveIndex;
	
	match(static_cast<unsigned char>(')'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mSTAR(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = STAR;
	int _saveIndex;
	
	match(static_cast<unsigned char>('*'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mDIV(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = DIV;
	int _saveIndex;
	
	match(static_cast<unsigned char>('/'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mPLUS(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = PLUS;
	int _saveIndex;
	
	match(static_cast<unsigned char>('+'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mMINUS(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = MINUS;
	int _saveIndex;
	
	match(static_cast<unsigned char>('-'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mSEMI(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = SEMI;
	int _saveIndex;
	
	match(static_cast<unsigned char>(';'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mCOLON(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = COLON;
	int _saveIndex;
	
	match(static_cast<unsigned char>(':'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mCOMMA(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = COMMA;
	int _saveIndex;
	
	match(static_cast<unsigned char>(','));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mAT(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = AT;
	int _saveIndex;
	
	match(static_cast<unsigned char>('@'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mEQUAL(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = EQUAL;
	int _saveIndex;
	
	match(static_cast<unsigned char>('='));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mGREATER(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = GREATER;
	int _saveIndex;
	
	match(static_cast<unsigned char>('>'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mLESS(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = LESS;
	int _saveIndex;
	
	match(static_cast<unsigned char>('<'));
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mGEQ(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = GEQ;
	int _saveIndex;
	
	match(">=");
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mLEQ(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = LEQ;
	int _saveIndex;
	
	match("<=");
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mNEQ(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = NEQ;
	int _saveIndex;
	
	match("<>");
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mLETTER(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = LETTER;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('a'):
	case static_cast<unsigned char>('b'):
	case static_cast<unsigned char>('c'):
	case static_cast<unsigned char>('d'):
	case static_cast<unsigned char>('e'):
	case static_cast<unsigned char>('f'):
	case static_cast<unsigned char>('g'):
	case static_cast<unsigned char>('h'):
	case static_cast<unsigned char>('i'):
	case static_cast<unsigned char>('j'):
	case static_cast<unsigned char>('k'):
	case static_cast<unsigned char>('l'):
	case static_cast<unsigned char>('m'):
	case static_cast<unsigned char>('n'):
	case static_cast<unsigned char>('o'):
	case static_cast<unsigned char>('p'):
	case static_cast<unsigned char>('q'):
	case static_cast<unsigned char>('r'):
	case static_cast<unsigned char>('s'):
	case static_cast<unsigned char>('t'):
	case static_cast<unsigned char>('u'):
	case static_cast<unsigned char>('v'):
	case static_cast<unsigned char>('w'):
	case static_cast<unsigned char>('x'):
	case static_cast<unsigned char>('y'):
	case static_cast<unsigned char>('z'):
	{
		matchRange(static_cast<unsigned char>('a'),static_cast<unsigned char>('z'));
		break;
	}
	case static_cast<unsigned char>('A'):
	case static_cast<unsigned char>('B'):
	case static_cast<unsigned char>('C'):
	case static_cast<unsigned char>('D'):
	case static_cast<unsigned char>('E'):
	case static_cast<unsigned char>('F'):
	case static_cast<unsigned char>('G'):
	case static_cast<unsigned char>('H'):
	case static_cast<unsigned char>('I'):
	case static_cast<unsigned char>('J'):
	case static_cast<unsigned char>('K'):
	case static_cast<unsigned char>('L'):
	case static_cast<unsigned char>('M'):
	case static_cast<unsigned char>('N'):
	case static_cast<unsigned char>('O'):
	case static_cast<unsigned char>('P'):
	case static_cast<unsigned char>('Q'):
	case static_cast<unsigned char>('R'):
	case static_cast<unsigned char>('S'):
	case static_cast<unsigned char>('T'):
	case static_cast<unsigned char>('U'):
	case static_cast<unsigned char>('V'):
	case static_cast<unsigned char>('W'):
	case static_cast<unsigned char>('X'):
	case static_cast<unsigned char>('Y'):
	case static_cast<unsigned char>('Z'):
	{
		matchRange(static_cast<unsigned char>('A'),static_cast<unsigned char>('Z'));
		break;
	}
	case static_cast<unsigned char>('_'):
	{
		match(static_cast<unsigned char>('_'));
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mATTRIBUTES(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = ATTRIBUTES;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>('x'):
	{
		match(static_cast<unsigned char>('x'));
		break;
	}
	case static_cast<unsigned char>('y'):
	{
		match(static_cast<unsigned char>('y'));
		break;
	}
	case static_cast<unsigned char>('a'):
	{
		match("angle");
		break;
	}
	case static_cast<unsigned char>('i'):
	{
		match("icon");
		break;
	}
	case static_cast<unsigned char>('m'):
	{
		match("mem");
		break;
	}
	case static_cast<unsigned char>('w'):
	{
		match("width");
		break;
	}
	case static_cast<unsigned char>('h'):
	{
		match("height");
		break;
	}
	case static_cast<unsigned char>('z'):
	{
		match("zoom");
		break;
	}
	case static_cast<unsigned char>('r'):
	{
		match("red");
		break;
	}
	case static_cast<unsigned char>('b'):
	{
		match("blue");
		break;
	}
	case static_cast<unsigned char>('v'):
	{
		match("visible");
		break;
	}
	default:
		if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('k')) && (LA(6) == static_cast<unsigned char>('x'))) {
			match("shockx");
		}
		else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('k')) && (LA(6) == static_cast<unsigned char>('y'))) {
			match("shocky");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('l'))) {
			match("color");
		}
		else if ((LA(1) == static_cast<unsigned char>('g')) && (LA(2) == static_cast<unsigned char>('r')) && (LA(3) == static_cast<unsigned char>('e'))) {
			match("green");
		}
		else if ((LA(1) == static_cast<unsigned char>('g')) && (LA(2) == static_cast<unsigned char>('r')) && (LA(3) == static_cast<unsigned char>('a'))) {
			match("gray");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('n'))) {
			match("contact");
		}
		else if ((LA(1) == static_cast<unsigned char>('d')) && (LA(2) == static_cast<unsigned char>('x'))) {
			match("dx");
		}
		else if ((LA(1) == static_cast<unsigned char>('d')) && (LA(2) == static_cast<unsigned char>('y'))) {
			match("dy");
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mSYNONYMS(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = SYNONYMS;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('g'):
	{
		match("grey");
		break;
	}
	case static_cast<unsigned char>('G'):
	{
		match("GREY");
		break;
	}
	case static_cast<unsigned char>('t'):
	{
		match("this");
		break;
	}
	case static_cast<unsigned char>('N'):
	{
		match("NULL");
		break;
	}
	case static_cast<unsigned char>('a'):
	{
		match("atan2");
		break;
	}
	default:
		if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('1'))) {
			match("nearest_indir1");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('2'))) {
			match("nearest_indir2");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('3'))) {
			match("nearest_indir3");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (true)) {
			match("nearest_indir");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('1'))) {
			match("nearest1");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('2'))) {
			match("nearest2");
		}
		else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('3'))) {
			match("nearest3");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('1'))) {
			match("light1");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('2'))) {
			match("light2");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('3'))) {
			match("light3");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (true)) {
			match("light");
		}
		else {
		}
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mFRENCH_VOCAB(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = FRENCH_VOCAB;
	int _saveIndex;
	
	switch ( LA(1)) {
	case static_cast<unsigned char>('a'):
	{
		match("alors");
		break;
	}
	case static_cast<unsigned char>('f'):
	{
		match("finsi");
		break;
	}
	case static_cast<unsigned char>('i'):
	{
		match("icone");
		break;
	}
	case static_cast<unsigned char>('h'):
	{
		match("hauteur");
		break;
	}
	case static_cast<unsigned char>('v'):
	{
		match("vert");
		break;
	}
	case static_cast<unsigned char>('b'):
	{
		match("bleu");
		break;
	}
	case static_cast<unsigned char>('g'):
	{
		match("gris");
		break;
	}
	case static_cast<unsigned char>('R'):
	{
		match("ROUGE");
		break;
	}
	case static_cast<unsigned char>('J'):
	{
		match("JAUNE");
		break;
	}
	case static_cast<unsigned char>('M'):
	{
		match("MAGENTA");
		break;
	}
	case static_cast<unsigned char>('C'):
	{
		match("CYAN");
		break;
	}
	case static_cast<unsigned char>('N'):
	{
		match("NOIR");
		break;
	}
	case static_cast<unsigned char>('G'):
	{
		match("GRIS");
		break;
	}
	case static_cast<unsigned char>('n'):
	{
		match("norme");
		break;
	}
	case static_cast<unsigned char>('o'):
	{
		match("ou");
		break;
	}
	case static_cast<unsigned char>('d'):
	{
		match("declic");
		break;
	}
	default:
		if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('1'))) {
			match("plusproche_vers1");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('2'))) {
			match("plusproche_vers2");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('3'))) {
			match("plusproche_vers3");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (true)) {
			match("plusproche_vers");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('g'))) {
			match("plusproche_gauche");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('d'))) {
			match("plusproche_droite");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('h'))) {
			match("plusproche_haut");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('b'))) {
			match("plusproche_bas");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('2'))) {
			match("plusproche2");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('1'))) {
			match("plusproche1");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('3'))) {
			match("plusproche3");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (true)) {
			match("plusproche");
		}
		else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('g'))) {
			match("touche_gauche");
		}
		else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('d'))) {
			match("touche_droite");
		}
		else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('h'))) {
			match("touche_haut");
		}
		else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('b'))) {
			match("touche_bas");
		}
		else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('e'))) {
			match("touche_espace");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('1'))) {
			match("lampe1");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('2'))) {
			match("lampe2");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('3'))) {
			match("lampe3");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('x'))) {
			match("chocx");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('y'))) {
			match("chocy");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (true)) {
			match("lampe");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('1'))) {
			match("ppv1");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('2'))) {
			match("ppv2");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('3'))) {
			match("ppv3");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('m'))) {
			match("comme");
		}
		else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('n'))) {
			match("sinon");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('r'))) {
			match("largeur");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u'))) {
			match("couleur");
		}
		else if ((LA(1) == static_cast<unsigned char>('B')) && (LA(2) == static_cast<unsigned char>('L')) && (LA(3) == static_cast<unsigned char>('E'))) {
			match("BLEU");
		}
		else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('I')) && (LA(3) == static_cast<unsigned char>('O'))) {
			match("VIOLET");
		}
		else if ((LA(1) == static_cast<unsigned char>('B')) && (LA(2) == static_cast<unsigned char>('L')) && (LA(3) == static_cast<unsigned char>('A'))) {
			match("BLANC");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('1'))) {
			match("pp1");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('2'))) {
			match("pp2");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('3'))) {
			match("pp3");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('g'))) {
			match("ppg");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('d'))) {
			match("ppd");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('h'))) {
			match("pph");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('b'))) {
			match("ppb");
		}
		else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('I')) && (LA(3) == static_cast<unsigned char>('D'))) {
			match("VIDE");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (true)) {
			match("ppv");
		}
		else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('i')) && (true)) {
			match("si");
		}
		else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('e'))) {
			match("met_en");
		}
		else if ((LA(1) == static_cast<unsigned char>('r')) && (LA(2) == static_cast<unsigned char>('o'))) {
			match("rouge");
		}
		else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('E'))) {
			match("VERT");
		}
		else if ((LA(1) == static_cast<unsigned char>('r')) && (LA(2) == static_cast<unsigned char>('a'))) {
			match("racine");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('a'))) {
			match("carre");
		}
		else if ((LA(1) == static_cast<unsigned char>('e')) && (LA(2) == static_cast<unsigned char>('n'))) {
			match("ent");
		}
		else if ((LA(1) == static_cast<unsigned char>('e')) && (LA(2) == static_cast<unsigned char>('t'))) {
			match("et");
		}
		else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('o'))) {
			match("souris");
		}
		else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('u'))) {
			match("mulot");
		}
		else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('o'))) {
			match("moi");
		}
		else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('u'))) {
			match("lui");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (true)) {
			match("pp");
		}
		else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('r'))) {
			match("prec");
		}
		else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('u'))) {
			match("suiv");
		}
		else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('l'))) {
			match("cliquee");
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mID(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = ID;
	int _saveIndex;
	
	bool synPredMatched271 = false;
	if (((_tokenSet_2.member(LA(1))) && (_tokenSet_3.member(LA(2))) && (_tokenSet_4.member(LA(3))) && (_tokenSet_5.member(LA(4))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true))) {
		int _m271 = mark();
		synPredMatched271 = true;
		inputState->guessing++;
		try {
			{
			mSYNONYMS(false);
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched271 = false;
		}
		rewind(_m271);
		inputState->guessing--;
	}
	if ( synPredMatched271 ) {
		{
		switch ( LA(1)) {
		case static_cast<unsigned char>('g'):
		{
			match("grey");
			if ( inputState->guessing==0 ) {
#line 1272 "calc.g"
				_ttype = LITERAL_gray;
#line 1368 "CalcLexer.cpp"
			}
			break;
		}
		case static_cast<unsigned char>('G'):
		{
			match("GREY");
			if ( inputState->guessing==0 ) {
#line 1273 "calc.g"
				_ttype = LITERAL_GRAY;
#line 1378 "CalcLexer.cpp"
			}
			break;
		}
		case static_cast<unsigned char>('t'):
		{
			match("this");
			if ( inputState->guessing==0 ) {
#line 1274 "calc.g"
				_ttype = LITERAL_me;
#line 1388 "CalcLexer.cpp"
			}
			break;
		}
		case static_cast<unsigned char>('N'):
		{
			match("NULL");
			if ( inputState->guessing==0 ) {
#line 1275 "calc.g"
				_ttype = LITERAL_EMPTY;
#line 1398 "CalcLexer.cpp"
			}
			break;
		}
		case static_cast<unsigned char>('a'):
		{
			match("atan2");
			if ( inputState->guessing==0 ) {
#line 1276 "calc.g"
				_ttype = LITERAL_ang;
#line 1408 "CalcLexer.cpp"
			}
			break;
		}
		default:
			if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('1'))) {
				match("nearest_indir1");
				if ( inputState->guessing==0 ) {
#line 1285 "calc.g"
					_ttype = LITERAL_nearest_in_dir;
#line 1418 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('2'))) {
				match("nearest_indir2");
				if ( inputState->guessing==0 ) {
#line 1286 "calc.g"
					_ttype = LITERAL_nearest_in_dir_second;
#line 1426 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (LA(14) == static_cast<unsigned char>('3'))) {
				match("nearest_indir3");
				if ( inputState->guessing==0 ) {
#line 1287 "calc.g"
					_ttype = LITERAL_nearest_in_dir_third;
#line 1434 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('_')) && (LA(9) == static_cast<unsigned char>('i')) && (LA(10) == static_cast<unsigned char>('n')) && (LA(11) == static_cast<unsigned char>('d')) && (LA(12) == static_cast<unsigned char>('i')) && (LA(13) == static_cast<unsigned char>('r')) && (true)) {
				match("nearest_indir");
				if ( inputState->guessing==0 ) {
#line 1284 "calc.g"
					_ttype = LITERAL_nearest_in_dir;
#line 1442 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('1'))) {
				match("nearest1");
				if ( inputState->guessing==0 ) {
#line 1281 "calc.g"
					_ttype = LITERAL_nearest;
#line 1450 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('2'))) {
				match("nearest2");
				if ( inputState->guessing==0 ) {
#line 1282 "calc.g"
					_ttype = LITERAL_nearest_second;
#line 1458 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('n')) && (LA(2) == static_cast<unsigned char>('e')) && (LA(3) == static_cast<unsigned char>('a')) && (LA(4) == static_cast<unsigned char>('r')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('s')) && (LA(7) == static_cast<unsigned char>('t')) && (LA(8) == static_cast<unsigned char>('3'))) {
				match("nearest3");
				if ( inputState->guessing==0 ) {
#line 1283 "calc.g"
					_ttype = LITERAL_nearest_third;
#line 1466 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('1'))) {
				match("light1");
				if ( inputState->guessing==0 ) {
#line 1278 "calc.g"
					_ttype = LITERAL_light_one;
#line 1474 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('2'))) {
				match("light2");
				if ( inputState->guessing==0 ) {
#line 1279 "calc.g"
					_ttype = LITERAL_light_two;
#line 1482 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (LA(6) == static_cast<unsigned char>('3'))) {
				match("light3");
				if ( inputState->guessing==0 ) {
#line 1280 "calc.g"
					_ttype = LITERAL_light_three;
#line 1490 "CalcLexer.cpp"
				}
			}
			else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('g')) && (LA(4) == static_cast<unsigned char>('h')) && (LA(5) == static_cast<unsigned char>('t')) && (true)) {
				match("light");
				if ( inputState->guessing==0 ) {
#line 1277 "calc.g"
					_ttype = LITERAL_light_one;
#line 1498 "CalcLexer.cpp"
				}
			}
		else {
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
	}
	else {
		bool synPredMatched274 = false;
		if (((_tokenSet_6.member(LA(1))) && (_tokenSet_7.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true))) {
			int _m274 = mark();
			synPredMatched274 = true;
			inputState->guessing++;
			try {
				{
				mFRENCH_VOCAB(false);
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched274 = false;
			}
			rewind(_m274);
			inputState->guessing--;
		}
		if ( synPredMatched274 ) {
			{
			switch ( LA(1)) {
			case static_cast<unsigned char>('a'):
			{
				match("alors");
				if ( inputState->guessing==0 ) {
#line 1293 "calc.g"
					_ttype = LITERAL_then;
#line 1533 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('f'):
			{
				match("finsi");
				if ( inputState->guessing==0 ) {
#line 1295 "calc.g"
					_ttype = LITERAL_endif;
#line 1543 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('i'):
			{
				match("icone");
				if ( inputState->guessing==0 ) {
#line 1297 "calc.g"
					_ttype = LITERAL_icon;
#line 1553 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('h'):
			{
				match("hauteur");
				if ( inputState->guessing==0 ) {
#line 1298 "calc.g"
					_ttype = LITERAL_height;
#line 1563 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('v'):
			{
				match("vert");
				if ( inputState->guessing==0 ) {
#line 1304 "calc.g"
					_ttype = LITERAL_green;
#line 1573 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('b'):
			{
				match("bleu");
				if ( inputState->guessing==0 ) {
#line 1305 "calc.g"
					_ttype = LITERAL_blue;
#line 1583 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('g'):
			{
				match("gris");
				if ( inputState->guessing==0 ) {
#line 1306 "calc.g"
					_ttype = LITERAL_gray;
#line 1593 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('R'):
			{
				match("ROUGE");
				if ( inputState->guessing==0 ) {
#line 1307 "calc.g"
					_ttype = LITERAL_RED;
#line 1603 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('J'):
			{
				match("JAUNE");
				if ( inputState->guessing==0 ) {
#line 1310 "calc.g"
					_ttype = LITERAL_YELLOW;
#line 1613 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('M'):
			{
				match("MAGENTA");
				if ( inputState->guessing==0 ) {
#line 1311 "calc.g"
					_ttype = LITERAL_PURPLE;
#line 1623 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('C'):
			{
				match("CYAN");
				if ( inputState->guessing==0 ) {
#line 1313 "calc.g"
					_ttype = LITERAL_CYAN;
#line 1633 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('N'):
			{
				match("NOIR");
				if ( inputState->guessing==0 ) {
#line 1315 "calc.g"
					_ttype = LITERAL_BLACK;
#line 1643 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('G'):
			{
				match("GRIS");
				if ( inputState->guessing==0 ) {
#line 1316 "calc.g"
					_ttype = LITERAL_GRAY;
#line 1653 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('n'):
			{
				match("norme");
				if ( inputState->guessing==0 ) {
#line 1319 "calc.g"
					_ttype = LITERAL_norm;
#line 1663 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('o'):
			{
				match("ou");
				if ( inputState->guessing==0 ) {
#line 1322 "calc.g"
					_ttype = LITERAL_or;
#line 1673 "CalcLexer.cpp"
				}
				break;
			}
			case static_cast<unsigned char>('d'):
			{
				match("declic");
				if ( inputState->guessing==0 ) {
#line 1351 "calc.g"
					_ttype = LITERAL_unclick;
#line 1683 "CalcLexer.cpp"
				}
				break;
			}
			default:
				if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('1'))) {
					match("plusproche_vers1");
					if ( inputState->guessing==0 ) {
#line 1358 "calc.g"
						_ttype = LITERAL_nearest_in_dir;
#line 1693 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('2'))) {
					match("plusproche_vers2");
					if ( inputState->guessing==0 ) {
#line 1359 "calc.g"
						_ttype = LITERAL_nearest_in_dir_second;
#line 1701 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (LA(16) == static_cast<unsigned char>('3'))) {
					match("plusproche_vers3");
					if ( inputState->guessing==0 ) {
#line 1360 "calc.g"
						_ttype = LITERAL_nearest_in_dir_third;
#line 1709 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('v')) && (LA(13) == static_cast<unsigned char>('e')) && (LA(14) == static_cast<unsigned char>('r')) && (LA(15) == static_cast<unsigned char>('s')) && (true)) {
					match("plusproche_vers");
					if ( inputState->guessing==0 ) {
#line 1357 "calc.g"
						_ttype = LITERAL_nearest_in_dir;
#line 1717 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('g'))) {
					match("plusproche_gauche");
					if ( inputState->guessing==0 ) {
#line 1339 "calc.g"
						_ttype = LITERAL_nearest_left;
#line 1725 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('d'))) {
					match("plusproche_droite");
					if ( inputState->guessing==0 ) {
#line 1340 "calc.g"
						_ttype = LITERAL_nearest_right;
#line 1733 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('h'))) {
					match("plusproche_haut");
					if ( inputState->guessing==0 ) {
#line 1341 "calc.g"
						_ttype = LITERAL_nearest_up;
#line 1741 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('_')) && (LA(12) == static_cast<unsigned char>('b'))) {
					match("plusproche_bas");
					if ( inputState->guessing==0 ) {
#line 1342 "calc.g"
						_ttype = LITERAL_nearest_down;
#line 1749 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('1'))) {
					match("plusproche1");
					if ( inputState->guessing==0 ) {
#line 1332 "calc.g"
						_ttype = LITERAL_nearest;
#line 1757 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('2'))) {
					match("plusproche2");
					if ( inputState->guessing==0 ) {
#line 1333 "calc.g"
						_ttype = LITERAL_nearest_second;
#line 1765 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (LA(11) == static_cast<unsigned char>('3'))) {
					match("plusproche3");
					if ( inputState->guessing==0 ) {
#line 1334 "calc.g"
						_ttype = LITERAL_nearest_third;
#line 1773 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('l')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('s')) && (LA(5) == static_cast<unsigned char>('p')) && (LA(6) == static_cast<unsigned char>('r')) && (LA(7) == static_cast<unsigned char>('o')) && (LA(8) == static_cast<unsigned char>('c')) && (LA(9) == static_cast<unsigned char>('h')) && (LA(10) == static_cast<unsigned char>('e')) && (true)) {
					match("plusproche");
					if ( inputState->guessing==0 ) {
#line 1331 "calc.g"
						_ttype = LITERAL_nearest;
#line 1781 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('g'))) {
					match("touche_gauche");
					if ( inputState->guessing==0 ) {
#line 1352 "calc.g"
						_ttype = LITERAL_key_left;
#line 1789 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('d'))) {
					match("touche_droite");
					if ( inputState->guessing==0 ) {
#line 1353 "calc.g"
						_ttype = LITERAL_key_right;
#line 1797 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('h'))) {
					match("touche_haut");
					if ( inputState->guessing==0 ) {
#line 1354 "calc.g"
						_ttype = LITERAL_key_up;
#line 1805 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('b'))) {
					match("touche_bas");
					if ( inputState->guessing==0 ) {
#line 1355 "calc.g"
						_ttype = LITERAL_key_down;
#line 1813 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('t')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('h')) && (LA(6) == static_cast<unsigned char>('e')) && (LA(7) == static_cast<unsigned char>('_')) && (LA(8) == static_cast<unsigned char>('e'))) {
					match("touche_espace");
					if ( inputState->guessing==0 ) {
#line 1356 "calc.g"
						_ttype = LITERAL_key_space;
#line 1821 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('1'))) {
					match("lampe1");
					if ( inputState->guessing==0 ) {
#line 1326 "calc.g"
						_ttype = LITERAL_light_one;
#line 1829 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('2'))) {
					match("lampe2");
					if ( inputState->guessing==0 ) {
#line 1327 "calc.g"
						_ttype = LITERAL_light_two;
#line 1837 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (LA(6) == static_cast<unsigned char>('3'))) {
					match("lampe3");
					if ( inputState->guessing==0 ) {
#line 1328 "calc.g"
						_ttype = LITERAL_light_three;
#line 1845 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('x'))) {
					match("chocx");
					if ( inputState->guessing==0 ) {
#line 1301 "calc.g"
						_ttype = LITERAL_shockx;
#line 1853 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('y'))) {
					match("chocy");
					if ( inputState->guessing==0 ) {
#line 1302 "calc.g"
						_ttype = LITERAL_shocky;
#line 1861 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('m')) && (LA(4) == static_cast<unsigned char>('p')) && (LA(5) == static_cast<unsigned char>('e')) && (true)) {
					match("lampe");
					if ( inputState->guessing==0 ) {
#line 1325 "calc.g"
						_ttype = LITERAL_light_one;
#line 1869 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('1'))) {
					match("ppv1");
					if ( inputState->guessing==0 ) {
#line 1362 "calc.g"
						_ttype = LITERAL_nearest_in_dir;
#line 1877 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('2'))) {
					match("ppv2");
					if ( inputState->guessing==0 ) {
#line 1363 "calc.g"
						_ttype = LITERAL_nearest_in_dir_second;
#line 1885 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (LA(4) == static_cast<unsigned char>('3'))) {
					match("ppv3");
					if ( inputState->guessing==0 ) {
#line 1364 "calc.g"
						_ttype = LITERAL_nearest_in_dir_third;
#line 1893 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('m'))) {
					match("comme");
					if ( inputState->guessing==0 ) {
#line 1291 "calc.g"
						_ttype = LITERAL_like;
#line 1901 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('i')) && (LA(3) == static_cast<unsigned char>('n'))) {
					match("sinon");
					if ( inputState->guessing==0 ) {
#line 1294 "calc.g"
						_ttype = LITERAL_else;
#line 1909 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('a')) && (LA(3) == static_cast<unsigned char>('r'))) {
					match("largeur");
					if ( inputState->guessing==0 ) {
#line 1299 "calc.g"
						_ttype = LITERAL_width;
#line 1917 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('u'))) {
					match("couleur");
					if ( inputState->guessing==0 ) {
#line 1300 "calc.g"
						_ttype = LITERAL_color;
#line 1925 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('B')) && (LA(2) == static_cast<unsigned char>('L')) && (LA(3) == static_cast<unsigned char>('E'))) {
					match("BLEU");
					if ( inputState->guessing==0 ) {
#line 1309 "calc.g"
						_ttype = LITERAL_BLUE;
#line 1933 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('I')) && (LA(3) == static_cast<unsigned char>('O'))) {
					match("VIOLET");
					if ( inputState->guessing==0 ) {
#line 1312 "calc.g"
						_ttype = LITERAL_PURPLE;
#line 1941 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('B')) && (LA(2) == static_cast<unsigned char>('L')) && (LA(3) == static_cast<unsigned char>('A'))) {
					match("BLANC");
					if ( inputState->guessing==0 ) {
#line 1314 "calc.g"
						_ttype = LITERAL_WHITE;
#line 1949 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('1'))) {
					match("pp1");
					if ( inputState->guessing==0 ) {
#line 1336 "calc.g"
						_ttype = LITERAL_nearest;
#line 1957 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('2'))) {
					match("pp2");
					if ( inputState->guessing==0 ) {
#line 1337 "calc.g"
						_ttype = LITERAL_nearest_second;
#line 1965 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('3'))) {
					match("pp3");
					if ( inputState->guessing==0 ) {
#line 1338 "calc.g"
						_ttype = LITERAL_nearest_third;
#line 1973 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('g'))) {
					match("ppg");
					if ( inputState->guessing==0 ) {
#line 1343 "calc.g"
						_ttype = LITERAL_nearest_left;
#line 1981 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('d'))) {
					match("ppd");
					if ( inputState->guessing==0 ) {
#line 1344 "calc.g"
						_ttype = LITERAL_nearest_right;
#line 1989 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('h'))) {
					match("pph");
					if ( inputState->guessing==0 ) {
#line 1345 "calc.g"
						_ttype = LITERAL_nearest_up;
#line 1997 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('b'))) {
					match("ppb");
					if ( inputState->guessing==0 ) {
#line 1346 "calc.g"
						_ttype = LITERAL_nearest_down;
#line 2005 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('I')) && (LA(3) == static_cast<unsigned char>('D'))) {
					match("VIDE");
					if ( inputState->guessing==0 ) {
#line 1349 "calc.g"
						_ttype = LITERAL_EMPTY;
#line 2013 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (LA(3) == static_cast<unsigned char>('v')) && (true)) {
					match("ppv");
					if ( inputState->guessing==0 ) {
#line 1361 "calc.g"
						_ttype = LITERAL_nearest_in_dir;
#line 2021 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('i')) && (true)) {
					match("si");
					if ( inputState->guessing==0 ) {
#line 1292 "calc.g"
						_ttype = LITERAL_if;
#line 2029 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('e'))) {
					match("met_en");
					if ( inputState->guessing==0 ) {
#line 1296 "calc.g"
						_ttype = LITERAL_move_to;
#line 2037 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('r')) && (LA(2) == static_cast<unsigned char>('o'))) {
					match("rouge");
					if ( inputState->guessing==0 ) {
#line 1303 "calc.g"
						_ttype = LITERAL_red;
#line 2045 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('V')) && (LA(2) == static_cast<unsigned char>('E'))) {
					match("VERT");
					if ( inputState->guessing==0 ) {
#line 1308 "calc.g"
						_ttype = LITERAL_GREEN;
#line 2053 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('r')) && (LA(2) == static_cast<unsigned char>('a'))) {
					match("racine");
					if ( inputState->guessing==0 ) {
#line 1317 "calc.g"
						_ttype = LITERAL_sqrt;
#line 2061 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('a'))) {
					match("carre");
					if ( inputState->guessing==0 ) {
#line 1318 "calc.g"
						_ttype = LITERAL_sqr;
#line 2069 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('e')) && (LA(2) == static_cast<unsigned char>('n'))) {
					match("ent");
					if ( inputState->guessing==0 ) {
#line 1320 "calc.g"
						_ttype = LITERAL_int;
#line 2077 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('e')) && (LA(2) == static_cast<unsigned char>('t'))) {
					match("et");
					if ( inputState->guessing==0 ) {
#line 1321 "calc.g"
						_ttype = LITERAL_and;
#line 2085 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('o'))) {
					match("souris");
					if ( inputState->guessing==0 ) {
#line 1323 "calc.g"
						_ttype = LITERAL_mouse;
#line 2093 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('u'))) {
					match("mulot");
					if ( inputState->guessing==0 ) {
#line 1324 "calc.g"
						_ttype = LITERAL_mouse;
#line 2101 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('m')) && (LA(2) == static_cast<unsigned char>('o'))) {
					match("moi");
					if ( inputState->guessing==0 ) {
#line 1329 "calc.g"
						_ttype = LITERAL_me;
#line 2109 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('l')) && (LA(2) == static_cast<unsigned char>('u'))) {
					match("lui");
					if ( inputState->guessing==0 ) {
#line 1330 "calc.g"
						_ttype = LITERAL_collider;
#line 2117 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('p')) && (true)) {
					match("pp");
					if ( inputState->guessing==0 ) {
#line 1335 "calc.g"
						_ttype = LITERAL_nearest;
#line 2125 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('p')) && (LA(2) == static_cast<unsigned char>('r'))) {
					match("prec");
					if ( inputState->guessing==0 ) {
#line 1347 "calc.g"
						_ttype = LITERAL_prev;
#line 2133 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('u'))) {
					match("suiv");
					if ( inputState->guessing==0 ) {
#line 1348 "calc.g"
						_ttype = LITERAL_next;
#line 2141 "CalcLexer.cpp"
					}
				}
				else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('l'))) {
					match("cliquee");
					if ( inputState->guessing==0 ) {
#line 1350 "calc.g"
						_ttype = LITERAL_clicked;
#line 2149 "CalcLexer.cpp"
					}
				}
			else {
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
		}
		else {
			bool synPredMatched268 = false;
			if (((_tokenSet_8.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true))) {
				int _m268 = mark();
				synPredMatched268 = true;
				inputState->guessing++;
				try {
					{
					mATTRIBUTES(false);
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched268 = false;
				}
				rewind(_m268);
				inputState->guessing--;
			}
			if ( synPredMatched268 ) {
				{
				switch ( LA(1)) {
				case static_cast<unsigned char>('x'):
				{
					match(static_cast<unsigned char>('x'));
					if ( inputState->guessing==0 ) {
#line 1252 "calc.g"
						_ttype = LITERAL_x;
#line 2184 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('y'):
				{
					match(static_cast<unsigned char>('y'));
					if ( inputState->guessing==0 ) {
#line 1253 "calc.g"
						_ttype = LITERAL_y;
#line 2194 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('a'):
				{
					match("angle");
					if ( inputState->guessing==0 ) {
#line 1254 "calc.g"
						_ttype = LITERAL_angle;
#line 2204 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('i'):
				{
					match("icon");
					if ( inputState->guessing==0 ) {
#line 1255 "calc.g"
						_ttype = LITERAL_icon;
#line 2214 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('m'):
				{
					match("mem");
					if ( inputState->guessing==0 ) {
#line 1256 "calc.g"
						_ttype = LITERAL_mem;
#line 2224 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('z'):
				{
					match("zoom");
					if ( inputState->guessing==0 ) {
#line 1257 "calc.g"
						_ttype = LITERAL_zoom;
#line 2234 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('h'):
				{
					match("height");
					if ( inputState->guessing==0 ) {
#line 1258 "calc.g"
						_ttype = LITERAL_height;
#line 2244 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('w'):
				{
					match("width");
					if ( inputState->guessing==0 ) {
#line 1259 "calc.g"
						_ttype = LITERAL_width;
#line 2254 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('r'):
				{
					match("red");
					if ( inputState->guessing==0 ) {
#line 1261 "calc.g"
						_ttype = LITERAL_red;
#line 2264 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('b'):
				{
					match("blue");
					if ( inputState->guessing==0 ) {
#line 1263 "calc.g"
						_ttype = LITERAL_blue;
#line 2274 "CalcLexer.cpp"
					}
					break;
				}
				case static_cast<unsigned char>('v'):
				{
					match("visible");
					if ( inputState->guessing==0 ) {
#line 1267 "calc.g"
						_ttype = LITERAL_visible;
#line 2284 "CalcLexer.cpp"
					}
					break;
				}
				default:
					if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('k')) && (LA(6) == static_cast<unsigned char>('x'))) {
						match("shockx");
						if ( inputState->guessing==0 ) {
#line 1265 "calc.g"
							_ttype = LITERAL_shockx;
#line 2294 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('s')) && (LA(2) == static_cast<unsigned char>('h')) && (LA(3) == static_cast<unsigned char>('o')) && (LA(4) == static_cast<unsigned char>('c')) && (LA(5) == static_cast<unsigned char>('k')) && (LA(6) == static_cast<unsigned char>('y'))) {
						match("shocky");
						if ( inputState->guessing==0 ) {
#line 1266 "calc.g"
							_ttype = LITERAL_shocky;
#line 2302 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('l'))) {
						match("color");
						if ( inputState->guessing==0 ) {
#line 1260 "calc.g"
							_ttype = LITERAL_color;
#line 2310 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('g')) && (LA(2) == static_cast<unsigned char>('r')) && (LA(3) == static_cast<unsigned char>('e'))) {
						match("green");
						if ( inputState->guessing==0 ) {
#line 1262 "calc.g"
							_ttype = LITERAL_green;
#line 2318 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('g')) && (LA(2) == static_cast<unsigned char>('r')) && (LA(3) == static_cast<unsigned char>('a'))) {
						match("gray");
						if ( inputState->guessing==0 ) {
#line 1264 "calc.g"
							_ttype = LITERAL_gray;
#line 2326 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('c')) && (LA(2) == static_cast<unsigned char>('o')) && (LA(3) == static_cast<unsigned char>('n'))) {
						match("contact");
						if ( inputState->guessing==0 ) {
#line 1268 "calc.g"
							_ttype = LITERAL_contact;
#line 2334 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('d')) && (LA(2) == static_cast<unsigned char>('x'))) {
						match("dx");
						if ( inputState->guessing==0 ) {
#line 1250 "calc.g"
							_ttype = LITERAL_dx;
#line 2342 "CalcLexer.cpp"
						}
					}
					else if ((LA(1) == static_cast<unsigned char>('d')) && (LA(2) == static_cast<unsigned char>('y'))) {
						match("dy");
						if ( inputState->guessing==0 ) {
#line 1251 "calc.g"
							_ttype = LITERAL_dy;
#line 2350 "CalcLexer.cpp"
						}
					}
				else {
					throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
			}
			else if ((_tokenSet_9.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
				mLETTER(false);
				{ // ( ... )*
				for (;;) {
					switch ( LA(1)) {
					case static_cast<unsigned char>('A'):
					case static_cast<unsigned char>('B'):
					case static_cast<unsigned char>('C'):
					case static_cast<unsigned char>('D'):
					case static_cast<unsigned char>('E'):
					case static_cast<unsigned char>('F'):
					case static_cast<unsigned char>('G'):
					case static_cast<unsigned char>('H'):
					case static_cast<unsigned char>('I'):
					case static_cast<unsigned char>('J'):
					case static_cast<unsigned char>('K'):
					case static_cast<unsigned char>('L'):
					case static_cast<unsigned char>('M'):
					case static_cast<unsigned char>('N'):
					case static_cast<unsigned char>('O'):
					case static_cast<unsigned char>('P'):
					case static_cast<unsigned char>('Q'):
					case static_cast<unsigned char>('R'):
					case static_cast<unsigned char>('S'):
					case static_cast<unsigned char>('T'):
					case static_cast<unsigned char>('U'):
					case static_cast<unsigned char>('V'):
					case static_cast<unsigned char>('W'):
					case static_cast<unsigned char>('X'):
					case static_cast<unsigned char>('Y'):
					case static_cast<unsigned char>('Z'):
					case static_cast<unsigned char>('_'):
					case static_cast<unsigned char>('a'):
					case static_cast<unsigned char>('b'):
					case static_cast<unsigned char>('c'):
					case static_cast<unsigned char>('d'):
					case static_cast<unsigned char>('e'):
					case static_cast<unsigned char>('f'):
					case static_cast<unsigned char>('g'):
					case static_cast<unsigned char>('h'):
					case static_cast<unsigned char>('i'):
					case static_cast<unsigned char>('j'):
					case static_cast<unsigned char>('k'):
					case static_cast<unsigned char>('l'):
					case static_cast<unsigned char>('m'):
					case static_cast<unsigned char>('n'):
					case static_cast<unsigned char>('o'):
					case static_cast<unsigned char>('p'):
					case static_cast<unsigned char>('q'):
					case static_cast<unsigned char>('r'):
					case static_cast<unsigned char>('s'):
					case static_cast<unsigned char>('t'):
					case static_cast<unsigned char>('u'):
					case static_cast<unsigned char>('v'):
					case static_cast<unsigned char>('w'):
					case static_cast<unsigned char>('x'):
					case static_cast<unsigned char>('y'):
					case static_cast<unsigned char>('z'):
					{
						mLETTER(false);
						break;
					}
					case static_cast<unsigned char>('0'):
					case static_cast<unsigned char>('1'):
					case static_cast<unsigned char>('2'):
					case static_cast<unsigned char>('3'):
					case static_cast<unsigned char>('4'):
					case static_cast<unsigned char>('5'):
					case static_cast<unsigned char>('6'):
					case static_cast<unsigned char>('7'):
					case static_cast<unsigned char>('8'):
					case static_cast<unsigned char>('9'):
					{
						matchRange(static_cast<unsigned char>('0'),static_cast<unsigned char>('9'));
						break;
					}
					default:
					{
						goto _loop277;
					}
					}
				}
				_loop277:;
				} // ( ... )*
			}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}}
	_ttype = testLiteralsTable(_ttype);
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}

void CalcLexer::mWS_(bool _createToken) {
	int _ttype; ANTLR_USE_NAMESPACE(antlr)RefToken _token; int _begin=text.length();
	_ttype = WS_;
	int _saveIndex;
	
	{
	switch ( LA(1)) {
	case static_cast<unsigned char>(' '):
	{
		match(static_cast<unsigned char>(' '));
		break;
	}
	case static_cast<unsigned char>('\t'):
	{
		match(static_cast<unsigned char>('\t'));
		break;
	}
	case static_cast<unsigned char>('\r'):
	{
		match(static_cast<unsigned char>('\r'));
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltForCharException(LA(1), getFilename(), getLine(), getColumn());
	}
	}
	}
	if ( inputState->guessing==0 ) {
#line 1374 "calc.g"
		_ttype = ANTLR_USE_NAMESPACE(antlr)Token::SKIP;
#line 2488 "CalcLexer.cpp"
	}
	if ( _createToken && _token==ANTLR_USE_NAMESPACE(antlr)nullToken && _ttype!=ANTLR_USE_NAMESPACE(antlr)Token::SKIP ) {
	   _token = makeToken(_ttype);
	   _token->setText(text.substr(_begin, text.length()-_begin));
	}
	_returnToken = _token;
	_saveIndex=0;
}


const unsigned long CalcLexer::_tokenSet_0_data_[] = { 4294958072UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 4294967295UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// NULL_TREE_LOOKAHEAD "if" "stop" "start" "restart" "like" "move_to" ID 
// COLON REF "x" "y" "dx" "dy" "angle" "icon" "color" "red" "green" "blue" 
// "gray" "shockx" "shocky" "width" "height" "zoom" "visible" "contact" 
// "mem" PLUS MINUS STAR DIV FLOAT INT "sqr" "sqrt" "abs" "sin" "cos" "tan" 
// "acs" "asn" "exp" "log" "clic" "click" "unclick" "clicked" "key_left" 
// "key_right" "key_up" "key_down" "key_space" "rnd" "srnd" "ang" "min" 
// "max" "int" "frac" "sgn" "norm" "mod" "dist" "t" "dt" EQUAL NEQ GREATER 
// GEQ LESS LEQ "and" "or" NEWLINE SEMI "then" "else" "endif" LPAREN COMMA 
// RPAREN "me" "prev" "next" "EMPTY" "camera" "light_one" "light_two" "light_three" 
// AT "mouse" "collider" "nearest" "nearest_second" "nearest_third" "nearest_left" 
// "nearest_right" "nearest_up" "nearest_down" "nearest_in_dir" "nearest_in_dir_second" 
// "nearest_in_dir_third" "PI" "pi" "Pi" "RED" "GREEN" "BLUE" "YELLOW" 
// "CYAN" "PURPLE" "WHITE" "BLACK" "GRAY" "ORANGE" COMMENT DIGITS LETTER 
// ATTRIBUTES SYNONYMS FRENCH_VOCAB WS_ 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_0(_tokenSet_0_data_,16);
const unsigned long CalcLexer::_tokenSet_1_data_[] = { 0UL, 67059712UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "acs" "exp" "log" "clic" "click" "unclick" "clicked" "key_left" "key_right" 
// "key_up" "key_down" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_1(_tokenSet_1_data_,10);
const unsigned long CalcLexer::_tokenSet_2_data_[] = { 0UL, 0UL, 16512UL, 1069186UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "dt" "and" "mouse" "nearest_right" "nearest_in_dir_third" "pi" "CYAN" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_2(_tokenSet_2_data_,10);
const unsigned long CalcLexer::_tokenSet_3_data_[] = { 0UL, 0UL, 2359296UL, 1311520UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "then" LPAREN "nearest_third" "nearest_up" "nearest_down" "BLUE" "CYAN" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_3(_tokenSet_3_data_,10);
const unsigned long CalcLexer::_tokenSet_4_data_[] = { 0UL, 0UL, 4128UL, 674UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "dist" LESS "mouse" "nearest_third" "nearest_right" "nearest_down" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_4(_tokenSet_4_data_,10);
const unsigned long CalcLexer::_tokenSet_5_data_[] = { 0UL, 0UL, 33558528UL, 34357504UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// LESS "prev" "nearest_up" "pi" "BLUE" "YELLOW" "ORANGE" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_5(_tokenSet_5_data_,10);
const unsigned long CalcLexer::_tokenSet_6_data_[] = { 0UL, 0UL, 4482188UL, 6157310UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "sgn" "norm" "dt" GREATER LEQ "and" "then" COMMA "mouse" "collider" 
// "nearest" "nearest_second" "nearest_third" "nearest_left" "nearest_right" 
// "nearest_up" "nearest_down" "nearest_in_dir_third" "PI" "pi" "Pi" "RED" 
// "BLUE" "YELLOW" "CYAN" "WHITE" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_6(_tokenSet_6_data_,10);
const unsigned long CalcLexer::_tokenSet_7_data_[] = { 0UL, 0UL, 33853986UL, 3527466UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "frac" "dist" NEQ LESS "or" "then" "prev" "mouse" "nearest" "nearest_third" 
// "nearest_up" "nearest_down" "nearest_in_dir_third" "pi" "Pi" "RED" "BLUE" 
// "CYAN" "PURPLE" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_7(_tokenSet_7_data_,10);
const unsigned long CalcLexer::_tokenSet_8_data_[] = { 0UL, 0UL, 0UL, 130818974UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "mouse" "collider" "nearest" "nearest_second" "nearest_right" "nearest_up" 
// "nearest_down" "PI" "BLUE" "YELLOW" "WHITE" "BLACK" "GRAY" "ORANGE" 
// COMMENT 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_8(_tokenSet_8_data_,10);
const unsigned long CalcLexer::_tokenSet_9_data_[] = { 0UL, 0UL, 2281701374UL, 134217726UL, 0UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "frac" "sgn" "norm" "mod" "dist" "t" "dt" EQUAL NEQ GREATER GEQ LESS 
// LEQ "and" "or" NEWLINE SEMI "then" "else" "endif" LPAREN COMMA RPAREN 
// "me" "prev" "next" "light_three" "mouse" "collider" "nearest" "nearest_second" 
// "nearest_third" "nearest_left" "nearest_right" "nearest_up" "nearest_down" 
// "nearest_in_dir" "nearest_in_dir_second" "nearest_in_dir_third" "PI" 
// "pi" "Pi" "RED" "GREEN" "BLUE" "YELLOW" "CYAN" "PURPLE" "WHITE" "BLACK" 
// "GRAY" "ORANGE" COMMENT 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcLexer::_tokenSet_9(_tokenSet_9_data_,10);

