# This file should be viewed as a -*- mode: Makefile -*-


include(../mobinet.pri)

SOURCES	+=	CWorld.cpp       \
			CInterface.cpp   \
			CVertex.cpp      \
			CViewer.cpp      \
			CMobile.cpp      \
			CalcLexer.cpp    \
			CalcParser.cpp   \
			CalcWalker.cpp   \
			CIconFactory.cpp \
			icones.cpp       \
			UDistance.cpp    \
			MyASTNode.cpp    \
			main.cpp


!isEmpty(HANDLE_GRAMMAR) {
    calc.target		=	CalcParser.cpp
    calc.commands	=	java antlr.Tool calc.g
    calc.depends	=	calc.g

    calc2.target	=	CalcLexer.cpp
    calc2.depends	=	CalcParser.cpp

    calc3.target	=	CalcLexer.hpp
    calc3.depends	=	CalcLexer.cpp

    calc4.target	=	CalcParser.hpp
    calc4.depends	=	CalcParser.cpp

    calc5.target	=	CalcWalker.hpp
    calc5.depends	=	CalcWalker.cpp

    calc6.target	=	CalcWalker.cpp
    calc6.depends	=	CalcParser.cpp

    QMAKE_EXTRA_UNIX_TARGETS	+=	calc6 calc5 calc4 calc3 calc2 calc calcMsg

    #system(echo "     Taking calc.g modifs into account")
}

HEADERS	+=	CWorld.h           \
                  CViewer.h          \
			CIconFactory.h     \
			CIcon.h		 \ 
			CInterface.h       \
			CReceiver.h        \
			CMobile.h          \
			CException.h       \
			CReceiver.h        \
			CVertex.h          \
			CVertex.inl        \
			icones.h           \
			UDistance.h	       \
			MyASTNode.h        \
			messages.h         \
			messages_calc.h    \
			messages_CVertex.h \
			messages_CMobile.h \
			messages_CInterface.h \
			messages_CWorld.h  \
			CalcLexer.hpp      \
			CalcParser.hpp     \
			CalcWalker.hpp     



Makefile.target		=	Makefile
Makefile.commands	=	qmake 
!isEmpty(IMAGIS) {
    Makefile.commands	+=	IMAGIS=1
}
!isEmpty(HANDLE_GRAMMAR) {
    Makefile.commands	+=	HANDLE_GRAMMAR=1
}
Makefile.depends	=	../mobinet.pri

TARGET		=	mobinet
unix:DESTDIR	=	../bin/linux
win32:DESTDIR	=	../bin/win32
macx:DESTDIR	=	../bin/OS-X


win32 : FORMS3	= interface.ui 
unix : FORMS	= interface.ui 

TEMPLATE	=	app 


CONFIG	+=	uic3 general qt opengl thread
QT		+=	opengl qt3support xml

isEmpty(DEBUG) {
    CONFIG	+= release
}
!isEmpty(DEBUG) {
    CONFIG	+= debug
}

DBFILE		=	mobile.db
LANGUAGE	=	C++

unix : LIBS	+=	-lglut
win32 : LIBS	+=	-lglut32
macx|darwin-g++ {
  # GLUT for Macintosh architecture
    QMAKE_LIBS -= -lglut
    QMAKE_LIBS *= -framework GLUT -lobjc
    QMAKE_POST_LINK =  cp -r ../mobiles ../bin/OS-X/mobinet.app/Contents/. && cp -r ../presets ../bin/OS-X/mobinet.app/Contents/.   && cp -r ../data ../bin/OS-X/mobinet.app/Contents/.

  # Qt3 only
  macx: CONFIG -= thread
}


# librairie libnetghost
INCLUDEPATH	+=	../lib/src/libnetghost
LIBS		+=	-lNetGhost

#librarie libpersist
INCLUDEPATH	+=	../lib/src/persist
LIBS		+=	-lPersistXml

# librairie libtexture
INCLUDEPATH	+=	../lib/src/libtexture
LIBS		+=	-lTexture

# librairie XML
INCLUDEPATH	+= 	$$XML2_INC_PATH 
unix : LIBS		+=	-L$$XML2_LIB_PATH -lxml2
win32: LIBS		+=	-L$$XML2_LIB_PATH -llibxml2

# librairie ANTLR
INCLUDEPATH	+=	$$ANTLR_INC_PATH
LIBS		+=	-L$$ANTLR_LIB_PATH -lantlr

# librarie SDL 
INCLUDEPATH	+=	$$SDL_INC_PATH
LIBS		+=	-L$$SDL_LIB_PATH -lSDL -lSDL_net -lSDLmain

#librairie jpeg
LIBS	        +=     -L$$JPEG_LIB_PATH -ljpeg

#iconv
INCLUDEPATH	+=	$$ICONV_INC_PATH

#QGLViewer
INCLUDEPATH	+=	$$QGLVIEWER_INC_PATH
unix: LIBS		+=	-L$$QGLVIEWER_LIB_PATH -lQGLViewer
win32: LIBS		+=	-L$$QGLVIEWER_LIB_PATH -lQGLViewer2

DEPENDPATH	*=	$$INCLUDEPATH
